local config_frame_name = "CraftBuster_ConfigFrame";

local frame = CreateFrame("Frame", config_frame_name, InterfaceOptionsFramePanelContainer);
frame.name = CBG_MOD_NAME;
frame:SetScript("OnShow", function(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	title:SetPoint("TOPLEFT", 16, -16);
	title:SetText(CBG_MOD_NAME .. " v" .. CBG_VERSION);
end);
frame:Hide();

InterfaceOptions_AddCategory(frame);

local child_config_frame = CreateFrame("Frame", config_frame_name .. "Config", frame);
child_config_frame.name = "Config";
child_config_frame.parent = CBG_MOD_NAME;
child_config_frame:SetScript("OnShow", function(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	title:SetPoint("TOPLEFT", 16, -16);
	title:SetText(CBG_MOD_NAME .. " - " .. CBL["CONFIG_CHILD_CONFIG"]);
end);
child_config_frame:Hide();

InterfaceOptions_AddCategory(child_config_frame);

local child_actions_frame = CreateFrame("Frame", config_frame_name .. "Actions", frame);
child_actions_frame.name = "Actions";
child_actions_frame.parent = CBG_MOD_NAME;
child_actions_frame:SetScript("OnShow", function(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	title:SetPoint("TOPLEFT", 16, -16);
	title:SetText(CBG_MOD_NAME .. " - " .. CBL["CONFIG_CHILD_ACTIONS"]);
end);
child_actions_frame:Hide();

InterfaceOptions_AddCategory(child_actions_frame);

local child_modules_frame = CreateFrame("Frame", config_frame_name .. "Modules", frame);
child_modules_frame.name = "Modules";
child_modules_frame.parent = CBG_MOD_NAME;
child_modules_frame:SetScript("OnShow", function(frame)
	local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	title:SetPoint("TOPLEFT", 16, -16);
	title:SetText(CBG_MOD_NAME .. " - " .. CBL["CONFIG_CHILD_MODULES"]);
end);
child_modules_frame:Hide();

InterfaceOptions_AddCategory(child_modules_frame);

function CraftBuster_Config_RegisterModule(module_id, module_name, module_options)
	local module_config_frame = module_options.config.frame;
	module_config_frame.name = module_options.config.name;
	module_config_frame.parent = panel_name;
	InterfaceOptions_AddCategory(module_config_frame);
end

function CraftBuster_Config_Show()
	InterfaceOptionsFrame_OpenToCategory(CBG_MOD_NAME);
end